/*--------------------------------------------------------
Project   : Home Control via Ethernet Version 1.0
Solution  : XPORT 03 AP
Display   : LCD 16 x 2
Compiler  : CCS C Compiler
Development Date: 3 Oct 2012
By        : Tumrobot
--------------------------------------------------------*/
//-------------------------------------------------------:INCLUDE
#include <18F458.h>               // Standard Header file - ¡ Header ͧä͹

// ӡ Setup fuse bit  ͡˹鹢ͧ MCU
#FUSES NOWDT                     //No Watch Dog Timer
#FUSES WDT128                    //Watch Dog Timer uses 1:128 Postscale
#FUSES HS                        //HS + 4x PLL
#FUSES NOPROTECT                 //Code not protected from reading
//#FUSES NOOSCSEN                  //Oscillator switching is disabled, main oscillator is source
#FUSES NOBROWNOUT                //No brownout reset
//#FUSES BORV20                    //Brownout reset at 2.0V
#FUSES NOPUT                     //No Power Up Timer
#FUSES NOCPD                     //No EE protection
#FUSES STVREN                    //Stack full/underflow will cause reset
#FUSES NODEBUG                   //No Debug mode for ICD
//#FUSES LVP                       //Low voltage prgming, B3(PIC16) or B5(PIC18) used for I/O
#FUSES NOWRT                     //Program memory not write protected
#FUSES NOWRTD                    //Data EEPROM not write protected
#FUSES NOWRTB                    //Boot block not write protected
#FUSES NOCPB                     //No Boot Block code protection
#FUSES NOWRTC                    //configuration not registers write protected
#FUSES NOEBTR                    //Memory not protected from table reads
#FUSES NOEBTRB                   //Boot block not protected from table reads*/

#use delay(clock=20000000,RESTART_WDT)           // oscillator for Boot Loader - ˹ͧ͡ MCU ӧҹ 20 MHz
//#use delay(clock=20000000) 

#use rs232(baud=9600 ,xmit=pin_C6,rcv=pin_C7,stream=XPORT,errors)			// ˹ Boudrate Ѻ RS-232

/* ------------------------------------------------------------------------- */
/* map reset vector and interrupt vector                                     */
/* 0x000-0x3FF is used by the bootloader. The bootloader maps the original   */
/* reset vector (0x000) to 0x400 and the interrupt vector (0x008) to 0x408.  */
/* ------------------------------------------------------------------------- */
#build (reset=0x400, interrupt=0x408)										//  reste vector 价 address 0x400 ԹѾ address 0x408
/* ------------------------------------------------------------------------- */
/* reserve boot block area                                                   */
/* This memory range is used by the bootloader, so the application must not  */
/* use this area.                                                            */
/* ------------------------------------------------------------------------- */
#org 0, 0x3FF {}															//ӧҹǹ  ʹ 0 仨֧ 0x3FF

#define TIMER1 30                     	//TIMER1 ˹  Over Flow ҡѺ 30

#include<string.h>						//  ź string

#include "HomeCtrl_header.h"			// ź HomeCtrl Header
#include "HomeCtrl_LCD.c"				// ź HomeCtrl LCD
#include "DS1302.c"						// ź DS1302
#include "XPORT_linker.c"				// ź Xport Linker
#include "Timer.c"						// ź Timer

//==========================================================
// Function blink_tmr1();
//==========================================================
void blink_tmr1()
{      
         int j;
         j++;								// j
         if(j <= TIMER1)					// j ¡Ҥҷ TIMER1 = 30
         {
            output_low(LED1);				//觻Դ LED1
         }

         if(j > TIMER1)						// j դҡ 30
         {
             output_high(LED1);				//Դ LED1
             fprintf(XPORT,"x");			//觤 X ѧ Xport ¡ҹ MAC Address  IP Address
         }

         if(j >= (TIMER1*2))				// j > 30ٳ2 ҡѺ 60
         {
            j = 0;							//ҧ j  ҡѺ 0
            output_low(LED1);				//觻Դ LED1
         }
   
}

//==============================================================
// This interrupt is used to TMR1 16 bit  The interrupt
// is automatically called =====================================
#INT_TIMER1
void over_timer1() 
    {
        set_timer1(0xFFFF);     //0xFC4F   // sets timer to interrupt in 200us      i++; ˹ Timer 1  0xFFFF 
        blink_tmr1();      		//  Timer 1 Դ  ¡ѧѹ blink_tmr1	
   }
//==============================================================

void main()									// ѧ Main
{
   set_tris_a(0b00100001);					// A0 = Input
   set_tris_b(0b00000000);                  // B4 = OP4,B2 = I/O, B1 = XPORT_RESET
   set_tris_c(0b10000000);					// C5 = LED1, C4 = LED2, C3 = LCD Backlight, C1 = OP6, C0 = OP5
   set_tris_d(0b00000000);                  // D3 = CE
   set_tris_e(0b00000000);					// E2 = OP3, E1 = OP2, E0 = OP1

   setup_timer_1(T1_INTERNAL|T1_DIV_BY_1); 	// setup interrupts TMR1
   enable_interrupts(INT_TIMER1);			// Դҹ ԡԹѾͧ MCU

   enable_interrupts(GLOBAL);               // enable global ints

   rtc_init();								// Innitail ͤ IC  DS1302

   delay_ms(1000);		
   output_high(LCD_BACKLIGHT);				// Դ BACK_LIGHT
   output_low(XPORT_RESET);					//  Reste XPORT
   delay_ms(500);
   output_high(XPORT_RESET);			

   output_high(LED2);                       //Դ LED 2
   output_high(LED1);						//Դ LED 1

   output_low(OP1);                     	//Դ Output1
   output_low(Op2);							//Դ Output2
   output_low(OP3);                     	//Դ Output3
   output_low(Op4);							//Դ Output4
   output_low(OP5);                     	//Դ Output5
   output_low(Op6);							//Դ Output6

	Cloase_BackLight = 0;
	Backligh_Ton = 0;

    InitialChip();							//ӧҹѺ LCD ¡ Clear Port D
    delay_ms(200);  
    InitialLCD();							// Innitail LCD
  //Set LCD
    WriteLCDCmd(LCD_FUNCTION_SET|LCD4BIT_MODE|LCD_LINE2|LCD_FONT_5X7); 	//˹ LCD ӧҹ MODE 4 Bit 2 ÷Ѵ ͹ 5x7
    WriteLCDCmd(DISPLAY_LCD|LCD_ON|LCD_CURSOR_OFF);						//Դʴ LCD лԴ Cursor
    WriteLCDCmd(LCD_ENTRY_MODE|INCREMENTS_LCD|NO_SCROLL_LCD);			// LCD 
    
   //Write char data in to CG-RAM
    WriteLCDCmd(LCD_CGRAM_ADDRESS);
    for(i=0;i<64;i++) 
      WriteLCDData(LCD_CUSTOM_CHARS[i]);								//¹ŧ RAM Ѻ LCD
    
   //Clear screen and move cursor to Line 1 Col1
    WriteLCDCmd(LCD_CLEAR_SCREEN);										//˹Ҩ LCD

      LCDGotoXY(1,1);
      printf(WriteLCDData,"Home Control    ");							//¹ͤŧ LCD ŧ㹺÷Ѵ 1
      LCDGotoXY(1,2);
      printf(WriteLCDData,"IP & Mac Setting");							//¹ͤŧ LCD ŧ㹺÷Ѵ 2

   //======================================================================
   // ????? MAC Address ?????? XPORT
   for(i = 0; i<26; i++)												//ǹٻ 26 Loop
   {
       MAC_String[i] = fgetc(XPORT);									//Ӣ MAC Address ҹҡ XPORT ¹ŧ MAC_String Arrey
      disable_interrupts(INT_TIMER1);									//Դҹ ԡԹѾ Timer1 
   }

   WriteLCDCmd(LCD_CLEAR_SCREEN);										//ӡҧ˹Ҩ LCD

   LCDGotoXY(1,1);														//价˹ LCD ˹ 1 ÷Ѵ 1
   printf(WriteLCDData,"MAC ");											//¹ MAC ŧ LCD
   LCDGotoXY(5,1);														//价˹ LCD ˹觷 5 ÷Ѵ 1

   for(i = 14; i<26; i++)												//ǹٻ 26 - 14 繨ӹǹ 13 ٻ
   {
      printf(WriteLCDData,"%C",MAC_String[i]);							//¹ MAC ŧ LCD
   }

   //=======================================================================

   fprintf(XPORT,"\n\r");												//觤 Enter ҹҧ RS232 ѧ XPORT

   for(i = 0; i<150; i++)												//ǹٻ 150 ͺ
   {
       IP_String[i] = fgetc(XPORT);										//ҹ IP_String ҡ Xport
   }

   LCDGotoXY(1,2);														//价˹ LCD ˹觷 1 ÷Ѵ 2
   printf(WriteLCDData,":");											//¹ : ŧ LCD
   for(i = 61; i<78; i++)												//Ѵҵ˹ 61 ֧ 78 
   {
      printf(WriteLCDData,"%C",IP_String[i]);							//¹˹ IP_String Ѵŧ LCD
   }

   delay_ms(3000);														//˹ǧ 3000 MS ҡѺ 3 Թҷ
   fprintf(XPORT,"9");													//¹ Ţ 9 价 Xport
   delay_ms(500);														//˹ǧ 500Ms 
   fprintf(XPORT,"\n\r");												//觤 Enter ҹҧ RS232 ѧ XPORT

   output_low(LED1);													//觻Դ LED1
   delay_ms(1000);														//˹ǧ 1000 MS ҡѺ 1 Թҷ

   output_high(LED2);                     	// Local Mode On			//Դ LED2
   output_high(LED1);													//Դ LED1

   enable_interrupts(INT_RDA);           	// enable RDA interrupts	//Դҹ ԡԹѾ

   Clear_Receive();														//¡ѧҧ Arrey ѺѺ

   LCDGotoXY(1,1);														//价 LCD ˹觷 1 ͧ÷Ѵ 1
   printf(WriteLCDData,"                ");								//źͤͧ÷Ѵ 1 ¹ ͤҧ 价 16 ˹

   output_low(LED2);													//觻Դ LED	

   while(1)																//ǹٻ 
   {
      XPORT_Receive();													//¡ѧҹŨҡ Xport
      Show_RTC();														//¡ѧҹѭҳԡ
      Check_Timer();													//Ǩͺõ

	  if(!input(Upgrade))												//Ǩͺա¡Ѿഷ 
	  {
			output_high(LED2);											//Դ LED2

			LCDGotoXY(1,1);												//价 LCD ˹觷 1 ÷Ѵ 1
   			printf(WriteLCDData,"Updating OS..   ");					//¹ Update OS... ѧ LCD

			while(!input(Upgrade));										//ǹٻ Ҩա¡ԡ ¡Ѿഷ 

	  }
	  else{ output_low(LED2); }											//觻Դ LED2


   }//end while
   
}// end main